Hex Artifact Content

Artifact 4aecbd19cc884bdc3cad3745c5cdc1fa00073c16:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 43 6c 65 61 6e 20 76 61  bash..# Clean va
0020: 72 69 61 62 6c 65 73 20 77 68 69 63 68 20 77 69  riables which wi
0030: 6c 6c 20 69 6e 74 65 72 66 65 72 65 20 77 69 74  ll interfere wit
0040: 68 20 74 68 65 20 62 75 69 6c 64 0a 75 6e 73 65  h the build.unse
0050: 74 20 4d 41 4b 45 46 4c 41 47 53 20 44 45 53 54  t MAKEFLAGS DEST
0060: 44 49 52 0a 0a 23 20 44 65 74 65 72 6d 69 6e 65  DIR..# Determine
0070: 20 61 70 70 72 6f 70 72 69 61 74 65 20 6d 6f 64   appropriate mod
0080: 65 0a 6d 6f 64 65 3d 22 62 75 69 6c 64 22 0a 63  e.mode="build".c
0090: 61 73 65 20 22 24 31 22 20 69 6e 0a 09 63 6c 65  ase "$1" in..cle
00a0: 61 6e 7c 64 69 73 74 63 6c 65 61 6e 7c 62 75 69  an|distclean|bui
00b0: 6c 64 7c 72 65 74 72 79 29 0a 09 09 6d 6f 64 65  ld|retry)...mode
00c0: 3d 22 24 31 22 0a 09 09 73 68 69 66 74 0a 09 09  ="$1"...shift...
00d0: 3b 3b 0a 65 73 61 63 0a 0a 23 20 44 65 74 65 72  ;;.esac..# Deter
00e0: 6d 69 6e 65 20 77 68 69 63 68 20 54 63 6c 20 76  mine which Tcl v
00f0: 65 72 73 69 6f 6e 20 74 6f 20 62 75 69 6c 64 0a  ersion to build.
0100: 54 43 4c 56 45 52 53 3d 22 38 2e 36 2e 36 22 0a  TCLVERS="8.6.6".
0110: 69 66 20 65 63 68 6f 20 22 24 31 22 20 7c 20 67  if echo "$1" | g
0120: 72 65 70 20 27 5e 5b 30 2d 39 5d 5b 30 2d 39 5d  rep '^[0-9][0-9]
0130: 2a 5c 2e 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  *\.' >/dev/null 
0140: 7c 7c 20 65 63 68 6f 20 22 24 31 22 20 7c 20 65  || echo "$1" | e
0150: 67 72 65 70 20 27 5e 28 63 76 73 7c 66 6f 73 73  grep '^(cvs|foss
0160: 69 6c 29 5f 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c  il)_' >/dev/null
0170: 3b 20 74 68 65 6e 0a 09 54 43 4c 56 45 52 53 3d  ; then..TCLVERS=
0180: 22 24 31 22 0a 0a 09 73 68 69 66 74 0a 66 69 0a  "$1"...shift.fi.
0190: 65 78 70 6f 72 74 20 54 43 4c 56 45 52 53 0a 0a  export TCLVERS..
01a0: 23 20 41 64 64 20 74 68 65 20 68 65 6c 70 65 72  # Add the helper
01b0: 73 20 64 69 72 65 63 74 6f 72 79 20 74 6f 20 74  s directory to t
01c0: 68 65 20 70 61 74 68 0a 50 41 54 48 3d 22 24 28  he path.PATH="$(
01d0: 63 64 20 22 24 28 64 69 72 6e 61 6d 65 20 22 24  cd "$(dirname "$
01e0: 28 77 68 69 63 68 20 22 24 30 22 29 22 29 22 20  (which "$0")")" 
01f0: 26 26 20 70 77 64 29 22 2f 63 6f 6d 6d 6f 6e 2f  && pwd)"/common/
0200: 68 65 6c 70 65 72 73 3a 22 24 7b 50 41 54 48 7d  helpers:"${PATH}
0210: 22 0a 65 78 70 6f 72 74 20 50 41 54 48 0a 0a 23  ".export PATH..#
0220: 20 56 65 72 69 66 79 20 74 68 61 74 20 22 70 72   Verify that "pr
0230: 65 2e 73 68 22 20 68 61 73 20 62 65 65 6e 20 72  e.sh" has been r
0240: 75 6e 20 69 66 20 74 68 69 73 20 69 73 20 61 20  un if this is a 
0250: 64 65 76 65 6c 6f 70 6d 65 6e 74 20 73 6e 61 70  development snap
0260: 73 68 6f 74 20 6f 66 0a 23 20 4b 69 74 43 72 65  shot of.# KitCre
0270: 61 74 6f 72 0a 69 66 20 5b 20 2d 66 20 27 62 75  ator.if [ -f 'bu
0280: 69 6c 64 2f 70 72 65 2e 73 68 27 20 5d 3b 20 74  ild/pre.sh' ]; t
0290: 68 65 6e 0a 09 69 66 20 21 20 66 69 6e 64 20 27  hen..if ! find '
02a0: 6b 69 74 73 68 2f 62 75 69 6c 64 73 72 63 2f 27  kitsh/buildsrc/'
02b0: 20 2d 6e 61 6d 65 20 63 6f 6e 66 69 67 75 72 65   -name configure
02c0: 20 2d 74 79 70 65 20 66 20 32 3e 2f 64 65 76 2f   -type f 2>/dev/
02d0: 6e 75 6c 6c 20 7c 20 67 72 65 70 20 63 6f 6e 66  null | grep conf
02e0: 69 67 75 72 65 20 3e 2f 64 65 76 2f 6e 75 6c 6c  igure >/dev/null
02f0: 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f 20 22 50  ; then...echo "P
0300: 6c 65 61 73 65 20 72 65 6d 65 6d 62 65 72 20 74  lease remember t
0310: 6f 20 72 75 6e 20 27 62 75 69 6c 64 2f 70 72 65  o run 'build/pre
0320: 2e 73 68 27 20 69 66 20 79 6f 75 20 65 78 70 65  .sh' if you expe
0330: 63 74 20 74 68 69 73 20 62 75 69 6c 64 20 74 6f  ct this build to
0340: 20 77 6f 72 6b 2e 22 20 3e 26 32 0a 09 66 69 0a   work." >&2..fi.
0350: 66 69 0a 0a 23 20 44 65 66 69 6e 65 20 74 68 65  fi..# Define the
0360: 20 6c 69 73 74 20 6f 66 20 61 6c 6c 20 70 61 63   list of all pac
0370: 6b 61 67 65 73 2c 20 66 6f 72 20 63 6c 65 61 6e  kages, for clean
0380: 69 6e 67 20 70 75 72 70 6f 73 65 73 0a 4b 49 54  ing purposes.KIT
0390: 43 52 45 41 54 4f 52 5f 41 4c 4c 50 4b 47 53 3d  CREATOR_ALLPKGS=
03a0: 22 6b 69 74 73 68 20 74 63 6c 20 74 63 6c 76 66  "kitsh tcl tclvf
03b0: 73 20 7a 6c 69 62 20 74 6b 20 69 74 63 6c 20 6d  s zlib tk itcl m
03c0: 6b 34 74 63 6c 20 74 68 72 65 61 64 20 64 62 75  k4tcl thread dbu
03d0: 73 20 74 6c 73 20 74 63 6c 78 20 74 63 63 34 74  s tls tclx tcc4t
03e0: 63 6c 20 74 63 6c 6c 69 62 20 75 64 70 20 79 61  cl tcllib udp ya
03f0: 6a 6c 74 63 6c 22 0a 0a 23 20 41 6c 77 61 79 73  jltcl"..# Always
0400: 20 72 65 62 75 69 6c 64 20 6b 69 74 73 68 0a 72   rebuild kitsh.r
0410: 6d 20 2d 66 20 22 6b 69 74 73 68 2f 2e 73 75 63  m -f "kitsh/.suc
0420: 63 65 73 73 22 0a 66 6f 72 20 70 6b 67 20 69 6e  cess".for pkg in
0430: 20 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 41 4c   ${KITCREATOR_AL
0440: 4c 50 4b 47 53 7d 20 24 7b 4b 49 54 43 52 45 41  LPKGS} ${KITCREA
0450: 54 4f 52 5f 50 4b 47 53 7d 3b 20 64 6f 0a 09 69  TOR_PKGS}; do..i
0460: 66 20 5b 20 22 24 7b 6d 6f 64 65 7d 22 20 21 3d  f [ "${mode}" !=
0470: 20 22 72 65 74 72 79 22 20 2d 6f 20 21 20 2d 66   "retry" -o ! -f
0480: 20 22 24 7b 70 6b 67 7d 2f 2e 73 75 63 63 65 73   "${pkg}/.succes
0490: 73 22 20 5d 3b 20 74 68 65 6e 0a 09 09 72 6d 20  s" ]; then...rm 
04a0: 2d 66 20 22 24 7b 70 6b 67 7d 2f 62 75 69 6c 64  -f "${pkg}/build
04b0: 2e 6c 6f 67 22 20 22 24 7b 70 6b 67 7d 2f 2e 73  .log" "${pkg}/.s
04c0: 75 63 63 65 73 73 22 0a 09 09 72 6d 20 2d 72 66  uccess"...rm -rf
04d0: 20 22 24 7b 70 6b 67 7d 2f 6f 75 74 22 20 22 24   "${pkg}/out" "$
04e0: 7b 70 6b 67 7d 2f 69 6e 73 74 22 20 22 24 7b 70  {pkg}/inst" "${p
04f0: 6b 67 7d 2f 62 75 69 6c 64 22 0a 0a 09 09 72 6d  kg}/build"....rm
0500: 20 2d 72 66 20 22 24 7b 70 6b 67 7d 2f 73 72 63   -rf "${pkg}/src
0510: 22 2f 74 6d 70 2d 2a 0a 09 66 69 0a 0a 09 69 66  "/tmp-*..fi...if
0520: 20 5b 20 22 24 7b 6d 6f 64 65 7d 22 20 3d 20 22   [ "${mode}" = "
0530: 64 69 73 74 63 6c 65 61 6e 22 20 5d 3b 20 74 68  distclean" ]; th
0540: 65 6e 0a 09 09 72 6d 20 2d 72 66 20 22 24 7b 70  en...rm -rf "${p
0550: 6b 67 7d 2f 73 72 63 22 0a 09 66 69 0a 64 6f 6e  kg}/src"..fi.don
0560: 65 0a 0a 23 20 57 65 27 72 65 20 61 6c 6c 20 64  e..# We're all d
0570: 6f 6e 65 20 69 66 20 77 65 27 72 65 20 69 6e 20  one if we're in 
0580: 63 6c 65 61 6e 20 6f 72 20 64 69 73 74 63 6c 65  clean or distcle
0590: 61 6e 20 6d 6f 64 65 0a 69 66 20 5b 20 22 24 7b  an mode.if [ "${
05a0: 6d 6f 64 65 7d 22 20 3d 20 22 63 6c 65 61 6e 22  mode}" = "clean"
05b0: 20 2d 6f 20 22 24 7b 6d 6f 64 65 7d 22 20 3d 20   -o "${mode}" = 
05c0: 22 64 69 73 74 63 6c 65 61 6e 22 20 5d 3b 20 74  "distclean" ]; t
05d0: 68 65 6e 0a 09 72 6d 20 2d 66 20 74 63 6c 6b 69  hen..rm -f tclki
05e0: 74 2d 2a 0a 09 72 6d 20 2d 66 20 6c 69 62 74 63  t-*..rm -f libtc
05f0: 6c 6b 69 74 2a 2e 2a 0a 0a 09 65 78 69 74 20 30  lkit*.*...exit 0
0600: 0a 66 69 0a 0a 23 20 41 64 64 20 70 61 63 6b 61  .fi..# Add packa
0610: 67 65 73 20 69 6d 70 6c 69 65 64 20 62 79 20 74  ges implied by t
0620: 68 65 20 61 64 64 69 74 69 6f 6e 61 6c 20 61 72  he additional ar
0630: 67 75 6d 65 6e 74 73 0a 69 66 20 5b 20 2d 7a 20  guments.if [ -z 
0640: 22 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b  "${KITCREATOR_PK
0650: 47 53 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 4b 49  GS}" ]; then..KI
0660: 54 43 52 45 41 54 4f 52 5f 50 4b 47 53 3d 22 74  TCREATOR_PKGS="t
0670: 6b 20 69 74 63 6c 20 6d 6b 34 74 63 6c 22 0a 66  k itcl mk4tcl".f
0680: 69 0a 0a 43 4f 4e 46 49 47 55 52 45 45 58 54 52  i..CONFIGUREEXTR
0690: 41 3d 22 24 40 22 0a 65 78 70 6f 72 74 20 43 4f  A="$@".export CO
06a0: 4e 46 49 47 55 52 45 45 58 54 52 41 0a 0a 69 66  NFIGUREEXTRA..if
06b0: 20 65 63 68 6f 20 22 20 24 7b 43 4f 4e 46 49 47   echo " ${CONFIG
06c0: 55 52 45 45 58 54 52 41 7d 20 22 20 7c 20 67 72  UREEXTRA} " | gr
06d0: 65 70 20 27 20 2d 2d 65 6e 61 62 6c 65 2d 74 68  ep ' --enable-th
06e0: 72 65 61 64 73 20 27 20 3e 2f 64 65 76 2f 6e 75  reads ' >/dev/nu
06f0: 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20  ll 2>/dev/null; 
0700: 74 68 65 6e 0a 09 4b 49 54 43 52 45 41 54 4f 52  then..KITCREATOR
0710: 5f 41 44 44 5f 45 4e 41 42 4c 45 5f 54 48 52 45  _ADD_ENABLE_THRE
0720: 41 44 53 3d 27 31 27 0a 09 4b 49 54 43 52 45 41  ADS='1'..KITCREA
0730: 54 4f 52 5f 50 4b 47 53 3d 22 24 7b 4b 49 54 43  TOR_PKGS="${KITC
0740: 52 45 41 54 4f 52 5f 50 4b 47 53 7d 20 74 68 72  REATOR_PKGS} thr
0750: 65 61 64 22 0a 65 6c 69 66 20 65 63 68 6f 20 22  ead".elif echo "
0760: 20 24 7b 43 4f 4e 46 49 47 55 52 45 45 58 54 52   ${CONFIGUREEXTR
0770: 41 7d 20 22 20 7c 20 67 72 65 70 20 27 20 2d 2d  A} " | grep ' --
0780: 64 69 73 61 62 6c 65 2d 74 68 72 65 61 64 73 20  disable-threads 
0790: 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f  ' >/dev/null 2>/
07a0: 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09  dev/null; then..
07b0: 4b 49 54 43 52 45 41 54 4f 52 5f 41 44 44 5f 45  KITCREATOR_ADD_E
07c0: 4e 41 42 4c 45 5f 54 48 52 45 41 44 53 3d 27 30  NABLE_THREADS='0
07d0: 27 0a 66 69 0a 0a 23 20 44 65 74 65 72 6d 69 6e  '.fi..# Determin
07e0: 65 20 63 72 6f 73 73 2d 63 6f 6d 70 69 6c 65 20  e cross-compile 
07f0: 73 74 61 74 75 73 0a 68 6f 73 74 5f 6f 73 3d 22  status.host_os="
0800: 24 28 65 63 68 6f 20 22 20 24 7b 43 4f 4e 46 49  $(echo " ${CONFI
0810: 47 55 52 45 45 58 54 52 41 7d 20 22 20 7c 20 73  GUREEXTRA} " | s
0820: 65 64 20 27 73 40 5e 2e 2a 20 2d 2d 68 6f 73 74  ed 's@^.* --host
0830: 3d 5c 28 5b 5e 20 5d 2a 5c 29 20 2e 2a 24 40 5c  =\([^ ]*\) .*$@\
0840: 31 40 0a 74 20 78 0a 64 0a 3a 78 27 29 22 0a 62  1@.t x.d.:x')".b
0850: 75 69 6c 64 5f 6f 73 3d 22 24 28 65 63 68 6f 20  uild_os="$(echo 
0860: 22 20 24 7b 43 4f 4e 46 49 47 55 52 45 45 58 54  " ${CONFIGUREEXT
0870: 52 41 7d 20 22 20 7c 20 73 65 64 20 27 73 40 5e  RA} " | sed 's@^
0880: 2e 2a 20 2d 2d 62 75 69 6c 64 3d 5c 28 5b 5e 20  .* --build=\([^ 
0890: 5d 2a 5c 29 20 2e 2a 24 40 5c 31 40 0a 74 20 78  ]*\) .*$@\1@.t x
08a0: 0a 64 0a 3a 78 27 29 22 0a 0a 69 66 20 5b 20 22  .d.:x')"..if [ "
08b0: 24 7b 68 6f 73 74 5f 6f 73 7d 22 20 21 3d 20 22  ${host_os}" != "
08c0: 24 7b 62 75 69 6c 64 5f 6f 73 7d 22 20 2d 61 20  ${build_os}" -a 
08d0: 2d 6e 20 22 24 7b 68 6f 73 74 5f 6f 73 7d 22 20  -n "${host_os}" 
08e0: 5d 3b 20 74 68 65 6e 0a 09 4b 43 5f 43 52 4f 53  ]; then..KC_CROS
08f0: 53 43 4f 4d 50 49 4c 45 3d 27 31 27 0a 09 4b 43  SCOMPILE='1'..KC
0900: 5f 43 52 4f 53 53 43 4f 4d 50 49 4c 45 5f 48 4f  _CROSSCOMPILE_HO
0910: 53 54 5f 4f 53 3d 22 24 7b 68 6f 73 74 5f 6f 73  ST_OS="${host_os
0920: 7d 22 0a 65 6c 73 65 0a 09 4b 43 5f 43 52 4f 53  }".else..KC_CROS
0930: 53 43 4f 4d 50 49 4c 45 3d 27 30 27 0a 09 4b 43  SCOMPILE='0'..KC
0940: 5f 43 52 4f 53 53 43 4f 4d 50 49 4c 45 5f 48 4f  _CROSSCOMPILE_HO
0950: 53 54 5f 4f 53 3d 27 27 0a 66 69 0a 65 78 70 6f  ST_OS=''.fi.expo
0960: 72 74 20 4b 43 5f 43 52 4f 53 53 43 4f 4d 50 49  rt KC_CROSSCOMPI
0970: 4c 45 20 4b 43 5f 43 52 4f 53 53 43 4f 4d 50 49  LE KC_CROSSCOMPI
0980: 4c 45 5f 48 4f 53 54 5f 4f 53 0a 0a 23 20 53 65  LE_HOST_OS..# Se
0990: 74 20 64 65 66 61 75 6c 74 20 74 61 72 67 65 74  t default target
09a0: 0a 4b 49 54 54 41 52 47 45 54 3d 22 6b 69 74 73  .KITTARGET="kits
09b0: 68 22 0a 65 78 70 6f 72 74 20 4b 49 54 54 41 52  h".export KITTAR
09c0: 47 45 54 0a 0a 23 20 46 69 78 20 75 70 20 70 61  GET..# Fix up pa
09d0: 63 6b 61 67 65 20 6c 69 73 74 0a 23 23 20 49 66  ckage list.## If
09e0: 20 62 75 69 6c 64 69 6e 67 20 4b 69 74 44 4c 4c   building KitDLL
09f0: 2c 20 64 65 66 69 6e 65 20 69 74 20 61 73 20 6f  , define it as o
0a00: 75 72 20 74 61 72 67 65 74 0a 69 66 20 65 63 68  ur target.if ech
0a10: 6f 20 22 20 24 7b 4b 49 54 43 52 45 41 54 4f 52  o " ${KITCREATOR
0a20: 5f 50 4b 47 53 7d 20 22 20 7c 20 67 72 65 70 20  _PKGS} " | grep 
0a30: 27 20 6b 69 74 64 6c 6c 20 27 20 3e 2f 64 65 76  ' kitdll ' >/dev
0a40: 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c  /null 2>/dev/nul
0a50: 6c 3b 20 74 68 65 6e 0a 09 4b 49 54 43 52 45 41  l; then..KITCREA
0a60: 54 4f 52 5f 50 4b 47 53 3d 22 24 28 65 63 68 6f  TOR_PKGS="$(echo
0a70: 20 22 20 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f   " ${KITCREATOR_
0a80: 50 4b 47 53 7d 20 22 20 7c 20 73 65 64 20 27 73  PKGS} " | sed 's
0a90: 40 20 6b 69 74 64 6c 6c 20 40 20 40 67 3b 73 40  @ kitdll @ @g;s@
0aa0: 5e 20 20 2a 40 40 3b 73 40 20 20 2a 24 40 40 3b  ^  *@@;s@  *$@@;
0ab0: 73 40 20 20 20 2a 40 20 40 67 27 29 22 0a 09 4b  s@   *@ @g')"..K
0ac0: 49 54 54 41 52 47 45 54 3d 22 6b 69 74 64 6c 6c  ITTARGET="kitdll
0ad0: 22 0a 66 69 0a 0a 23 20 49 66 20 74 68 65 20 75  ".fi..# If the u
0ae0: 73 65 72 20 6d 61 6e 75 61 6c 6c 79 20 72 65 71  ser manually req
0af0: 75 65 73 74 65 64 20 22 2d 2d 65 6e 61 62 6c 65  uested "--enable
0b00: 2d 6b 69 74 64 6c 6c 22 2c 20 6d 61 6b 65 20 69  -kitdll", make i
0b10: 74 20 73 6f 0a 69 66 20 65 63 68 6f 20 22 78 20  t so.if echo "x 
0b20: 24 40 20 22 20 7c 20 67 72 65 70 20 27 20 5b 2d  $@ " | grep ' [-
0b30: 5d 5b 2d 5d 65 6e 61 62 6c 65 2d 6b 69 74 64 6c  ][-]enable-kitdl
0b40: 6c 20 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32  l ' >/dev/null 2
0b50: 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e  >/dev/null; then
0b60: 0a 09 4b 49 54 54 41 52 47 45 54 3d 22 6b 69 74  ..KITTARGET="kit
0b70: 64 6c 6c 22 0a 66 69 0a 0a 23 23 20 49 66 20 62  dll".fi..## If b
0b80: 75 69 6c 64 69 6e 67 20 4b 69 74 44 4c 4c 20 61  uilding KitDLL a
0b90: 6e 64 20 54 6b 2c 20 6d 75 73 74 20 64 6f 20 54  nd Tk, must do T
0ba0: 6b 20 73 74 61 74 69 63 61 6c 6c 79 0a 23 23 23  k statically.###
0bb0: 20 28 57 65 6c 6c 2c 20 77 65 20 64 6f 6e 27 74   (Well, we don't
0bc0: 20 48 41 56 45 20 74 6f 2c 20 62 75 74 20 69 74   HAVE to, but it
0bd0: 20 77 6f 75 6c 64 20 64 65 66 65 61 74 20 6d 75   would defeat mu
0be0: 63 68 20 6f 66 20 74 68 65 20 70 75 72 70 6f 73  ch of the purpos
0bf0: 65 29 0a 69 66 20 5b 20 22 24 7b 4b 49 54 54 41  e).if [ "${KITTA
0c00: 52 47 45 54 7d 22 20 3d 20 22 6b 69 74 64 6c 6c  RGET}" = "kitdll
0c10: 22 20 5d 3b 20 74 68 65 6e 0a 09 69 66 20 65 63  " ]; then..if ec
0c20: 68 6f 20 22 20 24 7b 4b 49 54 43 52 45 41 54 4f  ho " ${KITCREATO
0c30: 52 5f 50 4b 47 53 7d 20 22 20 7c 20 67 72 65 70  R_PKGS} " | grep
0c40: 20 27 20 74 6b 20 27 20 3e 2f 64 65 76 2f 6e 75   ' tk ' >/dev/nu
0c50: 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20  ll 2>/dev/null; 
0c60: 74 68 65 6e 0a 09 09 69 66 20 5b 20 22 24 7b 53  then...if [ "${S
0c70: 54 41 54 49 43 54 4b 7d 22 20 21 3d 20 22 31 22  TATICTK}" != "1"
0c80: 20 2d 61 20 22 24 7b 53 54 41 54 49 43 54 4b 7d   -a "${STATICTK}
0c90: 22 20 21 3d 20 22 2d 31 22 20 5d 3b 20 74 68 65  " != "-1" ]; the
0ca0: 6e 0a 09 09 09 65 63 68 6f 20 27 57 61 72 6e 69  n....echo 'Warni
0cb0: 6e 67 3a 20 4c 69 6e 6b 69 6e 67 20 54 6b 20 73  ng: Linking Tk s
0cc0: 74 61 74 69 63 61 6c 6c 79 20 62 65 63 61 75 73  tatically becaus
0cd0: 65 20 79 6f 75 20 61 72 65 20 62 75 69 6c 64 69  e you are buildi
0ce0: 6e 67 20 4b 69 74 44 4c 4c 27 20 32 3e 26 31 0a  ng KitDLL' 2>&1.
0cf0: 09 09 09 65 63 68 6f 20 27 20 20 20 20 20 20 20  ...echo '       
0d00: 20 20 53 65 74 20 53 54 41 54 49 43 54 4b 20 74    Set STATICTK t
0d10: 6f 20 2d 31 20 69 66 20 79 6f 75 20 72 65 61 6c  o -1 if you real
0d20: 6c 79 20 77 61 6e 74 20 74 6f 20 6c 69 6e 6b 20  ly want to link 
0d30: 54 6b 20 64 79 6e 61 6d 69 63 61 6c 6c 79 2e 27  Tk dynamically.'
0d40: 20 3e 26 32 0a 0a 09 09 09 53 54 41 54 49 43 54   >&2.....STATICT
0d50: 4b 3d 22 31 22 0a 09 09 09 65 78 70 6f 72 74 20  K="1"....export 
0d60: 53 54 41 54 49 43 54 4b 0a 09 09 66 69 0a 09 66  STATICTK...fi..f
0d70: 69 0a 0a 09 69 66 20 65 63 68 6f 20 22 20 24 7b  i...if echo " ${
0d80: 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47 53 7d  KITCREATOR_PKGS}
0d90: 20 22 20 7c 20 67 72 65 70 20 27 20 6d 6b 34 74   " | grep ' mk4t
0da0: 63 6c 20 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  cl ' >/dev/null 
0db0: 32 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65  2>/dev/null; the
0dc0: 6e 0a 09 09 69 66 20 5b 20 2d 7a 20 22 24 7b 53  n...if [ -z "${S
0dd0: 54 41 54 49 43 4d 4b 34 7d 22 20 5d 3b 20 74 68  TATICMK4}" ]; th
0de0: 65 6e 0a 09 09 09 65 63 68 6f 20 27 57 61 72 6e  en....echo 'Warn
0df0: 69 6e 67 3a 20 4c 69 6e 6b 69 6e 67 20 4d 6b 34  ing: Linking Mk4
0e00: 74 63 6c 20 64 79 6e 61 6d 69 63 61 6c 6c 79 20  tcl dynamically 
0e10: 62 65 63 61 75 73 65 20 79 6f 75 20 61 72 65 20  because you are 
0e20: 62 75 69 6c 64 69 6e 67 20 4b 69 74 44 4c 4c 27  building KitDLL'
0e30: 20 32 3e 26 31 0a 09 09 09 65 63 68 6f 20 27 20   2>&1....echo ' 
0e40: 20 20 20 20 20 20 20 20 53 65 74 20 53 54 41 54          Set STAT
0e50: 49 43 4d 4b 34 20 74 6f 20 6d 61 6b 65 20 74 68  ICMK4 to make th
0e60: 69 73 20 6d 65 73 73 61 67 65 20 67 6f 20 61 77  is message go aw
0e70: 61 79 2e 27 20 3e 26 32 0a 09 09 09 65 63 68 6f  ay.' >&2....echo
0e80: 20 27 20 20 20 20 20 20 20 20 20 53 65 74 20 53   '         Set S
0e90: 54 41 54 49 43 4d 4b 34 20 74 6f 20 31 20 69 66  TATICMK4 to 1 if
0ea0: 20 79 6f 75 20 72 65 61 6c 6c 79 20 77 61 6e 74   you really want
0eb0: 20 74 6f 20 6c 69 6e 6b 20 4d 6b 34 74 63 6c 20   to link Mk4tcl 
0ec0: 73 74 61 74 69 63 61 6c 6c 79 20 28 6e 6f 72 6d  statically (norm
0ed0: 61 6c 20 64 65 66 61 75 6c 74 29 2e 27 20 3e 26  al default).' >&
0ee0: 32 0a 09 09 09 65 63 68 6f 20 27 20 20 20 20 20  2....echo '     
0ef0: 20 20 20 20 53 65 74 20 53 54 41 54 49 43 4d 4b      Set STATICMK
0f00: 34 20 74 6f 20 30 20 74 6f 20 6c 69 6e 6b 20 4d  4 to 0 to link M
0f10: 6b 34 74 63 6c 20 64 79 6e 61 6d 69 63 61 6c 6c  k4tcl dynamicall
0f20: 79 20 69 66 20 70 6f 73 73 69 62 6c 65 20 28 74  y if possible (t
0f30: 68 69 73 20 69 73 20 77 68 61 74 20 69 73 20 68  his is what is h
0f40: 61 70 70 65 6e 69 6e 67 20 6e 6f 77 29 2e 27 20  appening now).' 
0f50: 3e 26 32 0a 09 09 09 65 63 68 6f 20 27 20 20 20  >&2....echo '   
0f60: 20 20 20 20 20 20 53 65 74 20 53 54 41 54 49 43        Set STATIC
0f70: 4d 4b 34 20 74 6f 20 2d 31 20 74 6f 20 62 75 69  MK4 to -1 to bui
0f80: 6c 64 20 64 79 6e 61 6d 69 63 61 6c 6c 79 2e 27  ld dynamically.'
0f90: 20 3e 26 32 0a 0a 09 09 09 53 54 41 54 49 43 4d   >&2.....STATICM
0fa0: 4b 34 3d 22 30 22 0a 09 09 09 65 78 70 6f 72 74  K4="0"....export
0fb0: 20 53 54 41 54 49 43 4d 4b 34 0a 09 09 66 69 0a   STATICMK4...fi.
0fc0: 09 66 69 0a 66 69 0a 0a 23 20 46 69 6e 64 20 57  .fi.fi..# Find W
0fd0: 69 6e 64 6f 77 73 20 72 65 73 6f 75 72 63 65 2d  indows resource-
0fe0: 72 65 6c 61 74 65 64 20 66 69 6c 65 73 0a 69 66  related files.if
0ff0: 20 5b 20 2d 66 20 22 6b 69 74 2e 69 63 6f 22 20   [ -f "kit.ico" 
1000: 5d 3b 20 74 68 65 6e 0a 09 4b 49 54 43 52 45 41  ]; then..KITCREA
1010: 54 4f 52 5f 49 43 4f 4e 3d 22 24 28 70 77 64 29  TOR_ICON="$(pwd)
1020: 2f 6b 69 74 2e 69 63 6f 22 0a 65 6c 73 65 0a 09  /kit.ico".else..
1030: 4b 49 54 43 52 45 41 54 4f 52 5f 49 43 4f 4e 3d  KITCREATOR_ICON=
1040: 22 24 28 65 63 68 6f 20 22 24 28 70 77 64 29 2f  "$(echo "$(pwd)/
1050: 6b 69 74 73 68 2f 62 75 69 6c 64 73 72 63 22 2f  kitsh/buildsrc"/
1060: 6b 69 74 73 68 2d 2a 2f 74 63 6c 6b 69 74 2e 69  kitsh-*/tclkit.i
1070: 63 6f 29 22 0a 66 69 0a 69 66 20 5b 20 2d 66 20  co)".fi.if [ -f 
1080: 22 6b 69 74 2e 72 63 22 20 5d 3b 20 74 68 65 6e  "kit.rc" ]; then
1090: 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f 52 43 3d  ..KITCREATOR_RC=
10a0: 22 24 28 70 77 64 29 2f 6b 69 74 2e 72 63 22 0a  "$(pwd)/kit.rc".
10b0: 65 6c 73 65 0a 09 4b 49 54 43 52 45 41 54 4f 52  else..KITCREATOR
10c0: 5f 52 43 3d 22 24 28 65 63 68 6f 20 22 24 28 70  _RC="$(echo "$(p
10d0: 77 64 29 2f 6b 69 74 73 68 2f 62 75 69 6c 64 73  wd)/kitsh/builds
10e0: 72 63 22 2f 6b 69 74 73 68 2d 2a 2f 6b 69 74 2e  rc"/kitsh-*/kit.
10f0: 72 63 29 22 0a 66 69 0a 65 78 70 6f 72 74 20 4b  rc)".fi.export K
1100: 49 54 43 52 45 41 54 4f 52 5f 49 43 4f 4e 20 4b  ITCREATOR_ICON K
1110: 49 54 43 52 45 41 54 4f 52 5f 52 43 0a 0a 23 20  ITCREATOR_RC..# 
1120: 44 65 74 65 72 6d 69 6e 65 20 68 6f 77 20 77 65  Determine how we
1130: 20 69 6e 76 6f 6b 65 20 61 20 54 63 6c 20 69 6e   invoke a Tcl in
1140: 74 65 72 70 72 65 74 65 72 0a 69 66 20 5b 20 2d  terpreter.if [ -
1150: 7a 20 22 24 7b 54 43 4c 53 48 5f 4e 41 54 49 56  z "${TCLSH_NATIV
1160: 45 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 54 43 4c  E}" ]; then..TCL
1170: 53 48 5f 4e 41 54 49 56 45 3d 22 66 61 6c 73 65  SH_NATIVE="false
1180: 22 0a 66 69 0a 66 6f 72 20 74 65 73 74 73 68 20  ".fi.for testsh 
1190: 69 6e 20 22 24 7b 54 43 4c 53 48 5f 4e 41 54 49  in "${TCLSH_NATI
11a0: 56 45 7d 22 20 74 63 6c 73 68 20 74 63 6c 73 68  VE}" tclsh tclsh
11b0: 38 2e 34 20 74 63 6c 73 68 38 2e 35 20 74 63 6c  8.4 tclsh8.5 tcl
11c0: 73 68 38 2e 36 20 22 24 7b 54 43 4c 4b 49 54 3a  sh8.6 "${TCLKIT:
11d0: 2d 74 63 6c 6b 69 74 7d 22 3b 20 64 6f 0a 09 69  -tclkit}"; do..i
11e0: 66 20 65 63 68 6f 20 27 65 78 69 74 20 30 27 20  f echo 'exit 0' 
11f0: 7c 20 22 24 7b 74 65 73 74 73 68 7d 22 20 3e 2f  | "${testsh}" >/
1200: 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f  dev/null 2>/dev/
1210: 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 09 54 43 4c  null; then...TCL
1220: 53 48 5f 4e 41 54 49 56 45 3d 22 24 7b 74 65 73  SH_NATIVE="${tes
1230: 74 73 68 7d 22 0a 0a 09 09 62 72 65 61 6b 0a 09  tsh}"....break..
1240: 66 69 0a 64 6f 6e 65 0a 65 78 70 6f 72 74 20 54  fi.done.export T
1250: 43 4c 53 48 5f 4e 41 54 49 56 45 0a 0a 23 20 46  CLSH_NATIVE..# F
1260: 75 6e 63 74 69 6f 6e 20 74 6f 20 64 65 74 65 72  unction to deter
1270: 6d 69 6e 65 20 77 68 61 74 20 62 75 69 6c 64 20  mine what build 
1280: 6d 6f 64 65 20 69 73 20 62 65 69 6e 67 20 75 73  mode is being us
1290: 65 64 0a 66 75 6e 63 74 69 6f 6e 20 75 73 65 43  ed.function useC
12a0: 6f 6d 6d 6f 6e 42 75 69 6c 64 53 79 73 74 65 6d  ommonBuildSystem
12b0: 28 29 20 7b 0a 09 6c 6f 63 61 6c 20 73 63 72 69  () {..local scri
12c0: 70 74 0a 0a 09 73 63 72 69 70 74 3d 22 24 31 22  pt...script="$1"
12d0: 0a 0a 09 69 66 20 67 72 65 70 20 2d 69 20 27 5e  ...if grep -i '^
12e0: 23 20 2a 42 75 69 6c 64 43 6f 6d 70 61 74 69 62  # *BuildCompatib
12f0: 6c 65 3a 20 2a 4b 69 74 43 72 65 61 74 6f 72 20  le: *KitCreator 
1300: 2a 24 27 20 22 24 7b 73 63 72 69 70 74 7d 22 20  *$' "${script}" 
1310: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65  >/dev/null 2>/de
1320: 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 09 72  v/null; then...r
1330: 65 74 75 72 6e 20 30 0a 09 66 69 0a 0a 09 72 65  eturn 0..fi...re
1340: 74 75 72 6e 20 31 0a 7d 0a 0a 23 20 43 6c 65 61  turn 1.}..# Clea
1350: 6e 75 70 20 62 75 69 6c 64 20 6c 6f 67 73 0a 66  nup build logs.f
1360: 6f 72 20 70 6b 67 20 69 6e 20 74 63 6c 20 74 63  or pkg in tcl tc
1370: 6c 76 66 73 20 7a 6c 69 62 20 24 7b 4b 49 54 43  lvfs zlib ${KITC
1380: 52 45 41 54 4f 52 5f 50 4b 47 53 7d 20 6b 69 74  REATOR_PKGS} kit
1390: 73 68 3b 20 64 6f 0a 09 72 6d 20 2d 66 20 22 24  sh; do..rm -f "$
13a0: 7b 70 6b 67 7d 2f 62 75 69 6c 64 2e 6c 6f 67 22  {pkg}/build.log"
13b0: 0a 64 6f 6e 65 0a 0a 23 20 56 65 72 69 66 79 20  .done..# Verify 
13c0: 74 68 61 74 20 65 61 63 68 20 63 6f 6d 70 6f 6e  that each compon
13d0: 65 6e 74 20 69 73 20 68 61 70 70 79 20 77 69 74  ent is happy wit
13e0: 68 20 74 68 65 20 65 6e 76 69 72 6f 6e 6d 65 6e  h the environmen
13f0: 74 0a 76 61 6c 69 64 61 74 65 66 61 69 6c 65 64  t.validatefailed
1400: 3d 22 30 22 0a 66 6f 72 20 70 6b 67 20 69 6e 20  ="0".for pkg in 
1410: 74 63 6c 20 74 63 6c 76 66 73 20 7a 6c 69 62 20  tcl tclvfs zlib 
1420: 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b 47  ${KITCREATOR_PKG
1430: 53 7d 20 6b 69 74 73 68 3b 20 64 6f 0a 09 66 61  S} kitsh; do..fa
1440: 69 6c 65 64 3d 27 30 27 0a 09 69 66 20 5b 20 2d  iled='0'..if [ -
1450: 66 20 22 24 7b 70 6b 67 7d 2f 2e 73 75 63 63 65  f "${pkg}/.succe
1460: 73 73 22 20 5d 3b 20 74 68 65 6e 0a 09 09 63 6f  ss" ]; then...co
1470: 6e 74 69 6e 75 65 0a 09 66 69 0a 0a 09 69 66 20  ntinue..fi...if 
1480: 5b 20 2d 78 20 22 24 7b 70 6b 67 7d 2f 76 61 6c  [ -x "${pkg}/val
1490: 69 64 61 74 65 2e 73 68 22 20 5d 3b 20 74 68 65  idate.sh" ]; the
14a0: 6e 0a 09 09 28 0a 09 09 09 63 64 20 22 24 7b 70  n...(....cd "${p
14b0: 6b 67 7d 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  kg}" >/dev/null 
14c0: 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20 7c 7c 20 65  2>/dev/null || e
14d0: 78 69 74 20 31 0a 0a 09 09 09 2e 2f 76 61 6c 69  xit 1....../vali
14e0: 64 61 74 65 2e 73 68 20 33 3e 26 31 20 34 3e 26  date.sh 3>&1 4>&
14f0: 32 20 3e 3e 20 62 75 69 6c 64 2e 6c 6f 67 20 32  2 >> build.log 2
1500: 3e 26 31 20 7c 7c 20 65 78 69 74 20 31 0a 09 09  >&1 || exit 1...
1510: 29 20 7c 7c 20 66 61 69 6c 65 64 3d 22 31 22 0a  ) || failed="1".
1520: 0a 09 09 69 66 20 5b 20 22 24 7b 66 61 69 6c 65  ...if [ "${faile
1530: 64 7d 22 20 3d 20 27 31 27 20 5d 3b 20 74 68 65  d}" = '1' ]; the
1540: 6e 0a 09 09 09 65 63 68 6f 20 22 46 61 69 6c 65  n....echo "Faile
1550: 64 20 70 72 65 2d 72 65 71 75 69 73 69 74 65 20  d pre-requisite 
1560: 63 68 65 63 6b 20 66 6f 72 20 24 7b 70 6b 67 7d  check for ${pkg}
1570: 22 20 3e 26 32 0a 0a 09 09 09 76 61 6c 69 64 61  " >&2.....valida
1580: 74 65 66 61 69 6c 65 64 3d 27 31 27 0a 09 09 66  tefailed='1'...f
1590: 69 0a 09 66 69 0a 64 6f 6e 65 0a 0a 69 66 20 5b  i..fi.done..if [
15a0: 20 22 24 7b 76 61 6c 69 64 61 74 65 66 61 69 6c   "${validatefail
15b0: 65 64 7d 22 20 3d 20 27 31 27 20 5d 3b 20 74 68  ed}" = '1' ]; th
15c0: 65 6e 0a 09 65 78 69 74 20 31 0a 66 69 0a 0a 23  en..exit 1.fi..#
15d0: 20 44 6f 20 62 75 69 6c 64 0a 66 61 69 6c 65 64   Do build.failed
15e0: 70 6b 67 73 3d 22 22 0a 62 75 69 6c 64 66 61 69  pkgs="".buildfai
15f0: 6c 65 64 3d 22 30 22 0a 66 6f 72 20 70 6b 67 20  led="0".for pkg 
1600: 69 6e 20 74 63 6c 20 74 63 6c 76 66 73 20 7a 6c  in tcl tclvfs zl
1610: 69 62 20 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f  ib ${KITCREATOR_
1620: 50 4b 47 53 7d 20 6b 69 74 73 68 3b 20 64 6f 0a  PKGS} kitsh; do.
1630: 09 66 61 69 6c 65 64 3d 22 30 22 0a 09 69 66 20  .failed="0"..if 
1640: 5b 20 2d 66 20 22 24 7b 70 6b 67 7d 2f 2e 73 75  [ -f "${pkg}/.su
1650: 63 63 65 73 73 22 20 5d 3b 20 74 68 65 6e 0a 09  ccess" ]; then..
1660: 09 65 63 68 6f 20 2d 6e 20 22 53 6b 69 70 70 69  .echo -n "Skippi
1670: 6e 67 20 24 7b 70 6b 67 7d 20 2e 2e 2e 22 0a 09  ng ${pkg} ..."..
1680: 65 6c 73 65 0a 09 09 65 63 68 6f 20 2d 6e 20 22  else...echo -n "
1690: 42 75 69 6c 64 69 6e 67 20 24 7b 70 6b 67 7d 20  Building ${pkg} 
16a0: 2e 2e 2e 22 0a 0a 09 09 28 0a 09 09 09 63 64 20  ..."....(....cd 
16b0: 22 24 7b 70 6b 67 7d 22 20 3e 2f 64 65 76 2f 6e  "${pkg}" >/dev/n
16c0: 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 20  ull 2>/dev/null 
16d0: 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09 09 62 75  || exit 1.....bu
16e0: 69 6c 64 5f 73 63 72 69 70 74 3d 27 2e 2f 62 75  ild_script='./bu
16f0: 69 6c 64 2e 73 68 27 0a 09 09 09 69 66 20 5b 20  ild.sh'....if [ 
1700: 2d 78 20 27 6b 69 74 63 72 65 61 74 6f 72 2d 62  -x 'kitcreator-b
1710: 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68 65 6e  uild.sh' ]; then
1720: 0a 09 09 09 09 62 75 69 6c 64 5f 73 63 72 69 70  .....build_scrip
1730: 74 3d 27 2e 2f 6b 69 74 63 72 65 61 74 6f 72 2d  t='./kitcreator-
1740: 62 75 69 6c 64 2e 73 68 27 0a 09 09 09 66 69 0a  build.sh'....fi.
1750: 0a 09 09 09 69 66 20 5b 20 2d 66 20 22 24 7b 62  ....if [ -f "${b
1760: 75 69 6c 64 5f 73 63 72 69 70 74 7d 22 20 5d 3b  uild_script}" ];
1770: 20 74 68 65 6e 0a 09 09 09 09 62 75 69 6c 64 5f   then.....build_
1780: 73 63 72 69 70 74 73 3d 28 22 24 7b 62 75 69 6c  scripts=("${buil
1790: 64 5f 73 63 72 69 70 74 7d 22 29 0a 09 09 09 65  d_script}")....e
17a0: 6c 73 65 0a 09 09 09 09 62 75 69 6c 64 5f 73 63  lse.....build_sc
17b0: 72 69 70 74 73 3d 28 24 28 65 63 68 6f 20 62 75  ripts=($(echo bu
17c0: 69 6c 64 2d 6b 69 74 63 72 65 61 74 6f 72 2d 2a  ild-kitcreator-*
17d0: 2e 73 68 29 29 0a 09 09 09 66 69 0a 0a 09 09 09  .sh))....fi.....
17e0: 63 61 6c 6c 5f 70 6b 67 5f 69 6e 69 74 3d 27 31  call_pkg_init='1
17f0: 27 0a 09 09 09 66 6f 72 20 62 75 69 6c 64 5f 73  '....for build_s
1800: 63 72 69 70 74 20 69 6e 20 22 24 7b 62 75 69 6c  cript in "${buil
1810: 64 5f 73 63 72 69 70 74 73 5b 40 5d 7d 22 3b 20  d_scripts[@]}"; 
1820: 64 6f 0a 09 09 09 09 69 66 20 75 73 65 43 6f 6d  do.....if useCom
1830: 6d 6f 6e 42 75 69 6c 64 53 79 73 74 65 6d 20 22  monBuildSystem "
1840: 24 7b 62 75 69 6c 64 5f 73 63 72 69 70 74 7d 22  ${build_script}"
1850: 3b 20 74 68 65 6e 0a 09 09 09 09 09 28 0a 09 09  ; then......(...
1860: 09 09 09 09 2e 20 2e 2e 2f 63 6f 6d 6d 6f 6e 2f  ..... ../common/
1870: 63 6f 6d 6d 6f 6e 2e 73 68 0a 09 09 09 09 09 09  common.sh.......
1880: 2e 20 22 24 7b 62 75 69 6c 64 5f 73 63 72 69 70  . "${build_scrip
1890: 74 7d 22 0a 0a 09 09 09 09 09 09 73 65 74 20 2d  t}"........set -
18a0: 78 0a 0a 09 09 09 09 09 09 69 66 20 5b 20 22 24  x........if [ "$
18b0: 7b 63 61 6c 6c 5f 70 6b 67 5f 69 6e 69 74 7d 22  {call_pkg_init}"
18c0: 20 3d 20 27 31 27 20 5d 3b 20 74 68 65 6e 0a 09   = '1' ]; then..
18d0: 09 09 09 09 09 09 69 6e 69 74 20 7c 7c 20 64 69  ......init || di
18e0: 65 20 27 69 6e 69 74 20 66 61 69 6c 65 64 27 0a  e 'init failed'.
18f0: 09 09 09 09 09 09 66 69 0a 0a 09 09 09 09 09 09  ......fi........
1900: 70 72 65 64 6f 77 6e 6c 6f 61 64 20 7c 7c 20 64  predownload || d
1910: 69 65 20 27 70 72 65 64 6f 77 6e 6c 6f 61 64 20  ie 'predownload 
1920: 66 61 69 6c 65 64 27 0a 09 09 09 09 09 09 64 6f  failed'.......do
1930: 77 6e 6c 6f 61 64 20 7c 7c 20 64 69 65 20 27 64  wnload || die 'd
1940: 6f 77 6e 6c 6f 61 64 20 66 61 69 6c 65 64 27 0a  ownload failed'.
1950: 09 09 09 09 09 09 70 6f 73 74 64 6f 77 6e 6c 6f  ......postdownlo
1960: 61 64 20 7c 7c 20 64 69 65 20 27 70 6f 73 74 64  ad || die 'postd
1970: 6f 77 6e 6c 6f 61 64 20 66 61 69 6c 65 64 27 0a  ownload failed'.
1980: 0a 09 09 09 09 09 09 65 78 74 72 61 63 74 20 7c  .......extract |
1990: 7c 20 64 69 65 20 27 65 78 74 72 61 63 74 20 66  | die 'extract f
19a0: 61 69 6c 65 64 27 0a 0a 09 09 09 09 09 09 61 70  ailed'........ap
19b0: 70 6c 79 5f 70 61 74 63 68 65 73 20 7c 7c 20 64  ply_patches || d
19c0: 69 65 20 27 61 70 70 6c 79 20 70 61 74 63 68 65  ie 'apply patche
19d0: 73 20 66 61 69 6c 65 64 27 0a 0a 09 09 09 09 09  s failed'.......
19e0: 09 63 64 20 22 24 7b 77 6f 72 6b 64 69 72 7d 22  .cd "${workdir}"
19f0: 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09 09 09   || exit 1......
1a00: 09 09 70 72 65 63 6f 6e 66 69 67 75 72 65 20 7c  ..preconfigure |
1a10: 7c 20 64 69 65 20 27 70 72 65 63 6f 6e 66 69 67  | die 'preconfig
1a20: 75 72 65 20 66 61 69 6c 65 64 27 0a 09 09 09 09  ure failed'.....
1a30: 09 09 63 6f 6e 66 69 67 75 72 65 20 7c 7c 20 64  ..configure || d
1a40: 69 65 20 27 63 6f 6e 66 69 67 75 72 65 20 66 61  ie 'configure fa
1a50: 69 6c 65 64 27 0a 09 09 09 09 09 09 70 6f 73 74  iled'.......post
1a60: 63 6f 6e 66 69 67 75 72 65 20 7c 7c 20 64 69 65  configure || die
1a70: 20 27 70 6f 73 74 63 6f 6e 66 69 67 75 72 65 20   'postconfigure 
1a80: 66 61 69 6c 65 64 27 0a 0a 09 09 09 09 09 09 70  failed'........p
1a90: 72 65 62 75 69 6c 64 20 7c 7c 20 64 69 65 20 27  rebuild || die '
1aa0: 70 72 65 62 75 69 6c 64 20 66 61 69 6c 65 64 27  prebuild failed'
1ab0: 0a 09 09 09 09 09 09 62 75 69 6c 64 20 7c 7c 20  .......build || 
1ac0: 64 69 65 20 27 62 75 69 6c 64 20 66 61 69 6c 65  die 'build faile
1ad0: 64 27 0a 09 09 09 09 09 09 70 6f 73 74 62 75 69  d'.......postbui
1ae0: 6c 64 20 7c 7c 20 64 69 65 20 27 70 6f 73 74 62  ld || die 'postb
1af0: 75 69 6c 64 20 66 61 69 6c 65 64 27 0a 0a 09 09  uild failed'....
1b00: 09 09 09 09 70 72 65 69 6e 73 74 61 6c 6c 20 7c  ....preinstall |
1b10: 7c 20 64 69 65 20 27 70 72 65 69 6e 73 74 61 6c  | die 'preinstal
1b20: 6c 20 66 61 69 6c 65 64 27 0a 09 09 09 09 09 09  l failed'.......
1b30: 69 6e 73 74 61 6c 6c 20 7c 7c 20 64 69 65 20 27  install || die '
1b40: 69 6e 73 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a  install failed'.
1b50: 09 09 09 09 09 09 70 6f 73 74 69 6e 73 74 61 6c  ......postinstal
1b60: 6c 20 7c 7c 20 64 69 65 20 27 70 6f 73 74 69 6e  l || die 'postin
1b70: 73 74 61 6c 6c 20 66 61 69 6c 65 64 27 0a 0a 09  stall failed'...
1b80: 09 09 09 09 09 63 72 65 61 74 65 72 75 6e 74 69  .....createrunti
1b90: 6d 65 20 7c 7c 20 64 69 65 20 27 63 72 65 61 74  me || die 'creat
1ba0: 65 72 75 6e 74 69 6d 65 20 66 61 69 6c 65 64 27  eruntime failed'
1bb0: 0a 0a 09 09 09 09 09 09 73 65 74 20 2b 78 0a 09  ........set +x..
1bc0: 09 09 09 09 29 20 33 3e 26 31 20 34 3e 26 32 20  ....) 3>&1 4>&2 
1bd0: 3e 3e 20 62 75 69 6c 64 2e 6c 6f 67 20 32 3e 26  >> build.log 2>&
1be0: 31 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 09 09  1 || exit 1.....
1bf0: 65 6c 73 65 0a 09 09 09 09 09 22 24 7b 62 75 69  else......"${bui
1c00: 6c 64 5f 73 63 72 69 70 74 7d 22 20 33 3e 26 31  ld_script}" 3>&1
1c10: 20 34 3e 26 32 20 3e 3e 20 62 75 69 6c 64 2e 6c   4>&2 >> build.l
1c20: 6f 67 20 32 3e 26 31 20 7c 7c 20 65 78 69 74 20  og 2>&1 || exit 
1c30: 31 0a 09 09 09 09 66 69 0a 0a 09 09 09 09 63 61  1.....fi......ca
1c40: 6c 6c 5f 70 6b 67 5f 69 6e 69 74 3d 27 30 27 0a  ll_pkg_init='0'.
1c50: 09 09 09 64 6f 6e 65 0a 09 09 29 20 7c 7c 20 66  ...done...) || f
1c60: 61 69 6c 65 64 3d 22 31 22 0a 09 66 69 0a 0a 09  ailed="1"..fi...
1c70: 69 66 20 5b 20 22 24 7b 66 61 69 6c 65 64 7d 22  if [ "${failed}"
1c80: 20 3d 20 22 31 22 20 5d 3b 20 74 68 65 6e 0a 09   = "1" ]; then..
1c90: 09 65 63 68 6f 20 22 20 66 61 69 6c 65 64 2e 22  .echo " failed."
1ca0: 0a 09 09 66 61 69 6c 65 64 70 6b 67 73 3d 22 24  ...failedpkgs="$
1cb0: 7b 66 61 69 6c 65 64 70 6b 67 73 7d 20 24 7b 70  {failedpkgs} ${p
1cc0: 6b 67 7d 22 0a 09 65 6c 73 65 0a 09 09 65 63 68  kg}"..else...ech
1cd0: 6f 20 22 20 64 6f 6e 65 2e 22 0a 09 66 69 0a 0a  o " done."..fi..
1ce0: 09 63 61 73 65 20 22 24 7b 70 6b 67 7d 22 20 69  .case "${pkg}" i
1cf0: 6e 0a 09 09 74 63 6c 29 0a 09 09 09 54 43 4c 43  n...tcl)....TCLC
1d00: 4f 4e 46 49 47 44 49 52 3d 24 28 66 69 6e 64 20  ONFIGDIR=$(find 
1d10: 22 24 28 70 77 64 29 2f 74 63 6c 2f 62 75 69 6c  "$(pwd)/tcl/buil
1d20: 64 22 20 2d 6e 61 6d 65 20 74 63 6c 43 6f 6e 66  d" -name tclConf
1d30: 69 67 2e 73 68 20 7c 20 68 65 61 64 20 2d 31 20  ig.sh | head -1 
1d40: 7c 20 73 65 64 20 27 73 40 2f 5b 5e 2f 5d 2a 24  | sed 's@/[^/]*$
1d50: 40 40 27 29 0a 09 09 09 54 43 4c 43 4f 4e 46 49  @@')....TCLCONFI
1d60: 47 44 49 52 54 41 49 4c 3d 22 24 28 62 61 73 65  GDIRTAIL="$(base
1d70: 6e 61 6d 65 20 22 24 7b 54 43 4c 43 4f 4e 46 49  name "${TCLCONFI
1d80: 47 44 49 52 7d 22 29 22 0a 09 09 09 65 78 70 6f  GDIR}")"....expo
1d90: 72 74 20 54 43 4c 43 4f 4e 46 49 47 44 49 52 20  rt TCLCONFIGDIR 
1da0: 54 43 4c 43 4f 4e 46 49 47 44 49 52 54 41 49 4c  TCLCONFIGDIRTAIL
1db0: 0a 0a 09 09 09 23 20 49 66 20 54 63 6c 20 77 61  .....# If Tcl wa
1dc0: 73 20 63 6f 6d 70 69 6c 65 64 20 77 69 74 68 20  s compiled with 
1dd0: 74 68 72 65 61 64 73 20 65 6e 61 62 6c 65 64 20  threads enabled 
1de0: 70 61 73 73 20 2d 2d 65 6e 61 62 6c 65 2d 74 68  pass --enable-th
1df0: 72 65 61 64 73 20 74 6f 20 61 6c 6c 20 73 75 62  reads to all sub
1e00: 2d 70 72 6f 6a 65 63 74 73 0a 09 09 09 69 66 20  -projects....if 
1e10: 5b 20 22 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f  [ "${KITCREATOR_
1e20: 41 44 44 5f 45 4e 41 42 4c 45 5f 54 48 52 45 41  ADD_ENABLE_THREA
1e30: 44 53 3a 2d 31 7d 22 20 21 3d 20 27 30 27 20 5d  DS:-1}" != '0' ]
1e40: 3b 20 74 68 65 6e 0a 09 09 09 09 69 66 20 5b 20  ; then.....if [ 
1e50: 22 24 28 20 2e 20 22 24 7b 54 43 4c 43 4f 4e 46  "$( . "${TCLCONF
1e60: 49 47 44 49 52 7d 2f 74 63 6c 43 6f 6e 66 69 67  IGDIR}/tclConfig
1e70: 2e 73 68 22 20 26 26 20 65 63 68 6f 20 22 24 7b  .sh" && echo "${
1e80: 54 43 4c 5f 54 48 52 45 41 44 53 3a 2d 30 7d 22  TCL_THREADS:-0}"
1e90: 20 29 22 20 3d 20 27 31 27 20 5d 3b 20 74 68 65   )" = '1' ]; the
1ea0: 6e 0a 09 09 09 09 09 43 4f 4e 46 49 47 55 52 45  n......CONFIGURE
1eb0: 45 58 54 52 41 3d 22 24 7b 43 4f 4e 46 49 47 55  EXTRA="${CONFIGU
1ec0: 52 45 45 58 54 52 41 7d 20 2d 2d 65 6e 61 62 6c  REEXTRA} --enabl
1ed0: 65 2d 74 68 72 65 61 64 73 22 0a 09 09 09 09 66  e-threads".....f
1ee0: 69 0a 09 09 09 66 69 0a 09 09 09 3b 3b 0a 09 65  i....fi....;;..e
1ef0: 73 61 63 0a 0a 09 69 66 20 5b 20 22 24 7b 66 61  sac...if [ "${fa
1f00: 69 6c 65 64 7d 22 20 3d 20 22 31 22 20 5d 3b 20  iled}" = "1" ]; 
1f10: 74 68 65 6e 0a 09 09 62 75 69 6c 64 66 61 69 6c  then...buildfail
1f20: 65 64 3d 22 31 22 0a 09 65 6c 73 65 0a 09 09 74  ed="1"..else...t
1f30: 6f 75 63 68 20 22 24 7b 70 6b 67 7d 2f 2e 73 75  ouch "${pkg}/.su
1f40: 63 63 65 73 73 22 0a 09 66 69 0a 64 6f 6e 65 0a  ccess"..fi.done.
1f50: 0a 69 66 20 5b 20 2d 6e 20 22 24 7b 66 61 69 6c  .if [ -n "${fail
1f60: 65 64 70 6b 67 73 7d 22 20 5d 3b 20 74 68 65 6e  edpkgs}" ]; then
1f70: 0a 09 65 63 68 6f 20 22 46 61 69 6c 65 64 20 74  ..echo "Failed t
1f80: 6f 20 62 75 69 6c 64 3a 24 7b 66 61 69 6c 65 64  o build:${failed
1f90: 70 6b 67 73 7d 22 0a 66 69 0a 0a 69 66 20 5b 20  pkgs}".fi..if [ 
1fa0: 22 24 7b 62 75 69 6c 64 66 61 69 6c 65 64 7d 22  "${buildfailed}"
1fb0: 20 21 3d 20 22 30 22 20 5d 3b 20 74 68 65 6e 0a   != "0" ]; then.
1fc0: 09 65 63 68 6f 20 27 57 41 52 4e 49 4e 47 3a 20  .echo 'WARNING: 
1fd0: 42 75 69 6c 64 20 69 73 20 6c 69 6b 65 6c 79 20  Build is likely 
1fe0: 69 6e 63 6f 6d 70 6c 65 74 65 20 6f 72 20 66 61  incomplete or fa
1ff0: 69 6c 65 64 2e 27 20 3e 26 32 0a 66 69 0a 0a 63  iled.' >&2.fi..c
2000: 70 20 27 6b 69 74 73 68 2f 62 75 69 6c 64 27 2f  p 'kitsh/build'/
2010: 6b 69 74 73 68 2d 2a 2f 6c 69 62 74 63 6c 6b 69  kitsh-*/libtclki
2020: 74 2a 20 2e 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  t* . >/dev/null 
2030: 32 3e 2f 64 65 76 2f 6e 75 6c 6c 0a 63 70 20 27  2>/dev/null.cp '
2040: 6b 69 74 73 68 2f 62 75 69 6c 64 27 2f 6b 69 74  kitsh/build'/kit
2050: 73 68 2d 2a 2f 6b 69 74 20 22 74 63 6c 6b 69 74  sh-*/kit "tclkit
2060: 2d 24 7b 54 43 4c 56 45 52 53 7d 22 20 3e 2f 64  -${TCLVERS}" >/d
2070: 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e  ev/null 2>/dev/n
2080: 75 6c 6c 0a 69 66 20 5b 20 21 20 2d 66 20 22 74  ull.if [ ! -f "t
2090: 63 6c 6b 69 74 2d 24 7b 54 43 4c 56 45 52 53 7d  clkit-${TCLVERS}
20a0: 22 20 5d 3b 20 74 68 65 6e 0a 09 63 70 20 27 6b  " ]; then..cp 'k
20b0: 69 74 73 68 2f 62 75 69 6c 64 27 2f 6b 69 74 73  itsh/build'/kits
20c0: 68 2d 2a 2f 6b 69 74 2e 65 78 65 20 22 74 63 6c  h-*/kit.exe "tcl
20d0: 6b 69 74 2d 24 7b 54 43 4c 56 45 52 53 7d 22 20  kit-${TCLVERS}" 
20e0: 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65  >/dev/null 2>/de
20f0: 76 2f 6e 75 6c 6c 0a 66 69 0a 0a 66 6f 72 20 70  v/null.fi..for p
2100: 6f 73 74 73 63 72 69 70 74 20 69 6e 20 63 6f 6d  ostscript in com
2110: 6d 6f 6e 2f 70 6f 73 74 2f 2a 3b 20 64 6f 0a 09  mon/post/*; do..
2120: 69 66 20 5b 20 21 20 2d 66 20 22 24 7b 70 6f 73  if [ ! -f "${pos
2130: 74 73 63 72 69 70 74 7d 22 20 5d 3b 20 74 68 65  tscript}" ]; the
2140: 6e 0a 09 09 63 6f 6e 74 69 6e 75 65 0a 09 66 69  n...continue..fi
2150: 0a 0a 09 22 24 7b 70 6f 73 74 73 63 72 69 70 74  ..."${postscript
2160: 7d 22 0a 64 6f 6e 65 0a 0a 65 78 69 74 20 22 24  }".done..exit "$
2170: 7b 62 75 69 6c 64 66 61 69 6c 65 64 7d 22 0a     {buildfailed}".